package com.loafle.bridge.discoveryport.entity;

import com.loafle.bridge.discoveryport.constant.PortType;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Entity
public class DiscoveryPort {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

//    @ManyToOne
//    @JoinColumn(name = "HOST_ID", nullable = false)
//    private DiscoveryHost host;
//public DiscoveryHost getHost() {
//    return host;
//}
//
//    public void setHost(DiscoveryHost host) {
//        this.host = host;
//    }
    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private PortType portType;

    @Column(nullable = false)
    private short portNumber;

    @OneToMany(mappedBy = "port")
    private List<ServiceScanHistory> histories;

//    @OneToMany(mappedBy = "port")
//    private List<DiscoveryService> services;
//
//    public List<DiscoveryService> getServices() {
//        return services;
//    }
//
//    public void setServices(List<DiscoveryService> services) {
//        this.services = services;
//    }

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false)
    private Date updateDate;


    public DiscoveryPort() {}

    public DiscoveryPort(PortType type, short portNumber) {
        this.portType = type;
        this.portNumber = portNumber;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public PortType getPortType() {
        return portType;
    }

    public void setPortType(PortType portType) {
        this.portType = portType;
    }

    public short getPortNumber() {
        return portNumber;
    }

    public void setPortNumber(short portNumber) {
        this.portNumber = portNumber;
    }

    public List<ServiceScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<ServiceScanHistory> histories) {
        this.histories = histories;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getUpdateDate() {
        if (this.updateDate == null) {
            this.updateDate = new Date();
        }
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }
}
