package com.loafle.bridge.discoveryservice.repository;

import com.loafle.bridge.Application;
import com.loafle.bridge.discoveryport.constant.PortType;
import com.loafle.bridge.discoveryservice.entity.DiscoveryService;
import org.apache.log4j.Logger;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.List;

import static org.junit.Assert.assertEquals;

/**
 * Created by root on 16. 11. 16.
 */

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = Application.class)
public class DiscoveryServiceRepositoryTest {

    @Autowired
    private DiscoveryServiceRepository repo;
    private Logger log = Logger.getLogger(this.getClass());

    @Before
    public void Before() {
       repo.save(new DiscoveryService(PortType.TLS,"HTTP"));
        repo.save(new DiscoveryService(PortType.TCP,"WMI"));
        repo.save(new DiscoveryService(PortType.UDP,"DNS"));
    }

    @After
    public void After() {
        repo.deleteAll();
    }

    @Test
    public void TestBefore() {
        List<DiscoveryService> l = repo.findAll();
        assertEquals(3, l.size());
    }
}